package net.plil.clubinfo.etunicorn.app.personne;

import android.content.Context;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.v7.widget.LinearLayoutManager;
import android.support.v7.widget.ListPopupWindow;
import android.support.v7.widget.RecyclerView;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import net.plil.clubinfo.etunicorn.R;
import net.plil.clubinfo.etunicorn.app.FragmentNFC;
import net.plil.clubinfo.etunicorn.data.Permission;
import net.plil.clubinfo.etunicorn.data.Personne;
import net.plil.clubinfo.etunicorn.data.Role;

import java.sql.Date;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

/**
 * A fragment representing a list of Items.
 * <p/>
 * Activities containing this fragment MUST implement the {@link OnListFragmentInteractionListener}
 * interface.
 */
public class PersonneFragment extends FragmentNFC {

    private OnListFragmentInteractionListener mListener;

    /**
     * Mandatory empty constructor for the fragment manager to instantiate the
     * fragment (e.g. upon screen orientation changes).
     */
    public PersonneFragment() {
    }

    public static PersonneFragment newInstance() {
        return new PersonneFragment();
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_personne_list, container, false);

        // Set the adapter
        Context context = view.getContext();
        RecyclerView recyclerView = (RecyclerView) view.findViewById(R.id.personne_list);
        recyclerView.setLayoutManager(new LinearLayoutManager(context));

        List<Personne> personneList = new ArrayList<>();
        Role r = new Role();
        r.setName("ADMIN_TEST");
        Permission p = new Permission();
        p.setNom("Lire");
        r.getPermissions().add(p);
        p = new Permission();
        p.setNom("Ecrire");
        r.getPermissions().add(p);
        for (int i = 0;i<150;++i){
            Personne personne = new Personne();
            personne.setIdCarte("15245698547856");
            personne.setLoginPoly("bverhaeg");
            personne.setNaissance(new Date(System.currentTimeMillis()));
            personne.setSolde(45);
            personne.setRole(r);
            personneList.add(personne);
        }
        recyclerView.setAdapter(new MyPersonneRecyclerViewAdapter(personneList, mListener, getActivity()));

        FloatingActionButton fAB = (FloatingActionButton) view.findViewById(R.id.personne_add);
        fAB.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                CreatePersonne newFragment = new CreatePersonne();
                newFragment.show(getFragmentManager(), "CreateEvent");
            }
        });

        return view;
    }


    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
        if (context instanceof OnListFragmentInteractionListener) {
            mListener = (OnListFragmentInteractionListener) context;
        } else {
            throw new RuntimeException(context.toString()
                    + " must implement OnListFragmentInteractionListener");
        }
    }

    @Override
    public void onDetach() {
        super.onDetach();
        mListener = null;
    }

    @Override
    public void processNFC(String idCardUser) {

    }

    /**
     * This interface must be implemented by activities that contain this
     * fragment to allow an interaction in this fragment to be communicated
     * to the activity and potentially other fragments contained in that
     * activity.
     * <p/>
     * See the Android Training lesson <a href=
     * "http://developer.android.com/training/basics/fragments/communicating.html"
     * >Communicating with Other Fragments</a> for more information.
     */
    public interface OnListFragmentInteractionListener {
        // TODO: Update argument type and name
        void onListFragmentInteraction(Personne personne);
        void onListFragmentInteractionLong(Personne personne);
    }
}
